/* Ofront 1.1 */

#ifndef Unix__h
#define Unix__h

#include "SYSTEM.h"

struct Unix__1 {
	LONGINT fd, loc, size, bbase, entno, bsize;
};

typedef
	struct Unix__1 *Unix_Dir;

typedef
	struct Unix_DirEntDesc *Unix_DirEnt;

typedef
	struct Unix_DirEntDesc {
		LONGINT ino;
		INTEGER reclen, namlen;
		CHAR name[256];
	} Unix_DirEntDesc;

typedef
	SET Unix_FdSet[8];

typedef
	struct Unix_Hostent *Unix_HostEntry;

typedef
	struct Unix_Hostent {
		LONGINT name, aliases, addrtype, length, addrlist;
	} Unix_Hostent;

typedef
	struct Unix_JmpBuf {
		LONGINT _prvt0;
		char _prvt1[396];
	} Unix_JmpBuf;

typedef
	CHAR *Unix_Name;

typedef
	struct Unix_Timeval {
		LONGINT sec, usec;
	} Unix_Timeval;

typedef
	struct Unix_Rusage {
		Unix_Timeval utime, stime;
		LONGINT maxrss, ixrss, idrss, isrss, minflt, majflt, nswap, inblock, oublock;
		char _prvt0[4];
		LONGINT msgsnd, msgrcv, nsignals, nvcsw, nivcsw;
	} Unix_Rusage;

typedef
	struct Unix_SaveState {
		LONGINT grs[32];
		LONGINT pcoqHead;
		LONGREAL frs[32];
	} Unix_SaveState;

typedef
	void (*Unix_SignalHandler)();

typedef
	struct Unix_SigAction {
		Unix_SignalHandler handler;
		LONGINT mask[8];
		LONGINT flags;
	} Unix_SigAction;

typedef
	struct Unix_SigLocal {
		LONGINT arg[4];
		Unix_SaveState ss;
	} Unix_SigLocal;

typedef
	struct Unix_SigContext {
		Unix_SigLocal sl;
		LONGINT args[4];
	} Unix_SigContext;

typedef
	Unix_SigContext *Unix_SigCtxPtr;

typedef
	struct Unix_SigStack {
		LONGINT sp, onstack;
	} Unix_SigStack;

typedef
	struct Unix_SigVec {
		Unix_SignalHandler handle;
		SET mask, flags;
	} Unix_SigVec;

typedef
	struct Unix_Sockaddr {
		INTEGER family, port;
		LONGINT internetAddr;
		CHAR pad[8];
	} Unix_Sockaddr;

typedef
	struct Unix_Status {
		LONGINT dev, ino;
		INTEGER mode, nlink, reserved1, reserved2;
		LONGINT rdev, size, atime, spare1, mtime, spare2, ctime, spare3;
		SET flags;
		LONGINT netdev, netino;
		INTEGER cnode, rcnode, netsite, fstype;
		LONGINT realdev;
		INTEGER basemode, spareshort;
		LONGINT uid, gid;
		LONGINT spare4[3];
	} Unix_Status;

typedef
	struct Unix_Timezone {
		LONGINT minuteswest, dsttime;
	} Unix_Timezone;

typedef
	struct Unix_Tm {
		LONGINT sec, min, hour, mday, mon, year, wday, yday, isdst;
	} Unix_Tm;

typedef
	Unix_Tm *Unix_TmPtr;

typedef
	struct Unix_Tms {
		LONGINT uTime, sTime, cuTime, csTime;
	} Unix_Tms;

typedef
	Unix_Tms *Unix_TmsPtr;

typedef
	struct Unix_Utsname {
		CHAR sysname[9];
		CHAR nodename[9];
		CHAR release[9];
		CHAR version[9];
		CHAR machine[9];
		CHAR idnumber[15];
	} Unix_Utsname;



extern long *Unix_JmpBuf__typ;
extern long *Unix_Status__typ;
extern long *Unix_Timeval__typ;
extern long *Unix_Timezone__typ;
extern long *Unix_SigStack__typ;
extern long *Unix_SaveState__typ;
extern long *Unix_SigAction__typ;
extern long *Unix_SigLocal__typ;
extern long *Unix_SigContext__typ;
extern long *Unix_SigVec__typ;
extern long *Unix__1__typ;
extern long *Unix_DirEntDesc__typ;
extern long *Unix_Rusage__typ;
extern long *Unix_Tm__typ;
extern long *Unix_Tms__typ;
extern long *Unix_Utsname__typ;
extern long *Unix_Sockaddr__typ;
extern long *Unix_Hostent__typ;

extern LONGINT Unix_errno();
extern void *Unix__init();

#define Unix_Accept(socket, addr, addr__typ, addrlen)	accept(socket, addr, addrlen)
#define Unix_Bind(socket, name, namelen)	bind(socket, &(name), namelen)
#define Unix_Chdir(path, path__len)	chdir(path)
#define Unix_Chmod(path, path__len, mode)	chmod(path, mode)
#define Unix_Close(fd)	close(fd)
#define Unix_Connect(socket, name, namelen)	connect(socket, &(name), namelen)
#define Unix_Dup(fd)	dup(fd)
#define Unix_Dup2(fd1, fd2)	dup(fd1, fd2)
#define Unix_Exit(n)	exit(n)
#define Unix_Fchmod(fd, mode)	fchmod(fd, mode)
#define Unix_Fstat(fd, statbuf, statbuf__typ)	fstat(fd, statbuf)
#define Unix_Fsync(fd)	fsync(fd)
#define Unix_Ftruncate(fd, length)	ftruncate(fd, length)
#define Unix_Getegid()	getegid()
#define Unix_Geteuid()	geteuid()
#define Unix_Getgid()	getgid()
#define Unix_Gethostbyname(name, name__len)	(Unix_HostEntry)gethostbyname(name)
#define Unix_Gethostname(name, name__len)	gethostname(name, name__len)
#define Unix_Getpid()	getpid()
#define Unix_Getsockname(socket, name, name__typ, namelen)	getsockname(socket, name, namelen)
#define Unix_Gettimeofday(tv, tv__typ, tz, tz__typ)	gettimeofday(tv, tz)
#define Unix_Getuid()	getuid()
#define Unix_Ioctl(fd, request, arg)	ioctl(fd, request, arg)
#define Unix_Kill(pid, sig)	kill(pid, sig)
#define Unix_Listen(socket, backlog)	listen(socket, backlog)
#define Unix_Lseek(fd, offset, origin)	lseek(fd, offset, origin)
#define Unix_Open(name, name__len, flag, mode)	open(name, flag, mode)
#define Unix_Read(fd, buf, nbyte)	read(fd, buf, nbyte)
#define Unix_ReadBlk(fd, buf, buf__len)	read(fd, buf, buf__len)
#define Unix_Readblk(fd, buf, buf__len, len)	read(fd, buf, len)
#define Unix_Recv(socket, bufadr, buflen, flags)	recv(socket, bufadr, buflen, flags)
#define Unix_Rename(old, old__len, new, new__len)	rename(old, new)
#define Unix_Select(width, readfds, writefds, exceptfds, timeout, timeout__typ)	select(width, readfds, writefds, exceptfds, timeout)
#define Unix_Send(socket, bufadr, buflen, flags)	send(socket, bufadr, buflen, flags)
#define Unix_Sigsetmask(mask)	sigsetmask(mask)
#define Unix_Socket(af, type, protocol)	socket(af, type, protocol)
#define Unix_Stat(name, name__len, statbuf, statbuf__typ)	stat(name, statbuf)
#define Unix_Unlink(name, name__len)	unlink(name)
#define Unix_Write(fd, buf, nbyte)	write(fd, buf, nbyte)
#define Unix_WriteBlk(fd, buf, buf__len)	write(fd, buf, buf__len)

#endif
